<template>
  <div class="contenedor">
    <div id="coberturaOdometro" class="charts" ref="CoberturaOdometro001_004"></div>
  </div>
</template>

<style scoped>
</style>

<script>
import htmlToImage from "html-to-image";
import * as am4core from "@amcharts/amcharts4/core";
import * as am4charts from "@amcharts/amcharts4/charts";
import am4themes_animated from "@amcharts/amcharts4/themes/animated";
import am4themes_material from "@amcharts/amcharts4/themes/material";
import axios from "axios";

export default {
  name: "CoberturaOdometro001_004",
  props: {
    filtros: Object,
  },
  data() {
    return {
      value: 0,
      valueTotal: 0,
      color: "",
      diasRest: 0,
      isShowId: true
    };
  },
  methods: {
    initChartG() {
      const self = this
      am4core.useTheme(am4themes_animated);
      // Create chart instance
      var chart = am4core.create("coberturaOdometro", am4charts.RadarChart);
      chart.logo.hidden = true;
      // Add data
      chart.data = [
        {
          category: "",
          value: this.value,
          full: this.valueTotal,
        },
      ];

      // Make chart not full circle
      chart.startAngle = -180;
      chart.endAngle = 0;
      chart.innerRadius = am4core.percent(90);

      // Set number format
      chart.numberFormatter.numberFormat = "#.#";

      // Create axes
      var categoryAxis = chart.yAxes.push(new am4charts.CategoryAxis());
      categoryAxis.dataFields.category = "category";
      categoryAxis.renderer.grid.template.location = 100;
      categoryAxis.renderer.grid.template.strokeOpacity = 0;
      categoryAxis.renderer.labels.template.horizontalCenter = "right";
      categoryAxis.renderer.labels.template.fontWeight = 20;
      categoryAxis.renderer.labels.template.adapter.add("fill", function (
        fill,
        target
      ) {
        return target.dataItem.index >= 0
          ? chart.colors.getIndex(target.dataItem.index)
          : fill;
      });
      categoryAxis.renderer.minGridDistance = 300;

      var label = chart.createChild(am4core.Label);
      label.text = this.value;
      label.fontSize = 40;
      label.align = "center";
      label.isMeasured = false;
      label.x = am4core.percent(50);
      label.y = am4core.percent(35);
      label.horizontalCenter = "middle";
      label.fontWeight = "bolder";

      var label1 = chart.createChild(am4core.Label);
      label1.text = "Puntos de Venta Certificados";
      label1.fontSize = 10;
      label1.align = "center";
      label1.isMeasured = false;
      label1.x = am4core.percent(50);
      label1.y = am4core.percent(50);
      label1.horizontalCenter = "middle";
      label1.fontWeight = "bolder";

      var label2 = chart.createChild(am4core.Label);
      label2.text =
        "¡Quedan " + this.diasRest + " días para alcanzar la cobertura!";
      label2.fontSize = 12;
      label2.align = "center";
      label2.isMeasured = false;
      label2.x = am4core.percent(50);
      label2.y = am4core.percent(60);
      label2.horizontalCenter = "middle";
      label2.fontWeight = "bold";

      var label3 = chart.createChild(am4core.Label);
      label3.text = "Cobertura total: " + this.valueTotal + " Puntos de Venta";
      label3.fontSize = 10;
      label3.align = "center";
      label3.isMeasured = false;
      label3.x = am4core.percent(50);
      label3.y = am4core.percent(67);
      label3.horizontalCenter = "middle";
      label3.fontWeight = "bold";
      label3.color = am4core.color("grey");

      var valueAxis = chart.xAxes.push(new am4charts.ValueAxis());
      valueAxis.renderer.grid.template.strokeOpacity = 0;
      valueAxis.min = 0;
      valueAxis.max = this.valueTotal;
      valueAxis.strictMinMax = true;

      // Create series
      var series1 = chart.series.push(new am4charts.RadarColumnSeries());
      series1.dataFields.valueX = "full";
      series1.dataFields.categoryY = "category";
      series1.clustered = false;
      series1.columns.template.fill = new am4core.InterfaceColorSet().getFor(
        "alternativeBackground"
      );
      series1.columns.template.fillOpacity = 0.08;
      series1.columns.template.cornerRadiusTopLeft = 20;
      series1.columns.template.strokeWidth = 0;
      series1.columns.template.radarColumn.cornerRadius = 20;

      var series2 = chart.series.push(new am4charts.RadarColumnSeries());
      series2.dataFields.valueX = "value";
      series2.dataFields.categoryY = "category";
      series2.clustered = false;
      series2.columns.template.strokeWidth = 0;
      series2.columns.template.radarColumn.cornerRadius = 20;
      series2.columns.template.adapter.add("fill", function (fill, target) {
        return am4core.color(self.color);
      });

      // Add cursor
      //chart.cursor = new am4charts.RadarCursor();
    },

    getCobertura(){
      const self = this;
      let url = "/franquicia/dashboard/g001/secure/grafico/get/odometro/?" +
            "fechaInicial="+ self.filtros.fechaInicio+"&"+
            "fechaFin="+self.filtros.fechaFin+"&"+
            "idNegocio="+self.filtros.idNegocio;

      if (self.filtros.idGerente){
        url  = url + "&idGerente="+self.filtros.idGerente
      }
      axios
        .get(
          url
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setValores(data[0]);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    setValores(data){
      this.value = data.cobertura_certificacion
      this.valueTotal = data.cobertura_total
      this.diasRest = data.dias_restantes
      this.color = data.rango_color
     
      this.initChartG();
    }
  },
  mounted() {
   
  },
  created(){
    this.getCobertura() 
  }
};
</script>
<style scoped>
#coberturaOdometro {
  width: 100%;
  height: 350px; /* heightGrafica */
  margin: auto;
}
</style>